/*
 * @copyright		© Copyright 2006-2011, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.externalcontent.gadget.twitter
 *
 * @revision		$Revision: 1.1.2.1.2.1 $
 */

jQuery.plugin('de_epages.externalcontent.gadget.twitter', {
  plugin : ['de_epages.core', 'jQuery.uid', 'jQuery.tmpl', 'jQuery.ui.widget']
}, function ($) {
  // Constants.
  var gClassNames = 'SocialWeb',
      twitterButtonTemplate = '<a class="twitter-${type}-button"'
      + 'href="https://twitter.com/{{if type==="follow"}}${username}"{{else}}share" {{if username}}data-via="${username}"{{/if}}{{/if}}'
      + '{{if type==="follow"}} data-show-count="${showcount}" data-show-screen-name="${showScreenName}"{{/if}} data-url="${url}" data-count="${count}" {{if text}}data-text="${text}"{{/if}}>'
      +	'{{if type==="follow"}}Follow ${username}{{else}}Tweet{{/if}}</a>';

  $.widget('de_epages.externalcontent.gadget.Twitter', {

    options : {
      url : ep.config.canonicalUrl ? ep.config.canonicalUrl : ep.config.webUrl,
      type : "share", 								// expects one of the following values: share, follow, profile, or search; default: share
      username : "",							// expects the username from which the tweets should be shown or the username for "via", if type "share".
      text : $(document).attr('title'),										// Default Tweet text
      count : 'none',							// String specifying the count annotation rendering. Possible values: 'none', 'vertical', 'horizontal'.
      showcount : false							// the User's followers count is not displayed with the Follow Button
    },

     _create : function () {
       var self = this,
           o = self.options,
           type = o.type;

      // with EPG-28229 we removed the types "profile" and "search"
      // but it is possible that merchants have still these types in their shop
      // so we will only render the supported types
      if ((type === 'share') || (type === 'follow')) {
      	self._twitterButton();
      }
    },

    _twitterButton : function () {
      var self = this,
          o = self.options,
          pluginName = 'de_epages.externalcontent.gadget.twitter';

      // Render and cache template.
      if (!$.template[pluginName]) {
        $.template(pluginName, twitterButtonTemplate);
      }

      // Append button placeholder.
      self.renderedTemplate = $.tmpl(pluginName, o).appendTo(self.element.addClass(gClassNames));

      // Load Twitter Button API.
      $.ajax({
        dataType : 'script',
        url : '//platform.twitter.com/widgets.js',
        cache : true,
      })
        .done(function () {
          // Render button.
          twttr.widgets.load();
        });
    },

    destroy : function () {
      // Remove all traces of the widget.
      var self = this;
      self.element.removeClass(gClassNames);
      self.TWTRWidget && self.TWTRWidget.destroy();
      self.renderedTemplate.remove();
      self.Inherited(arguments);
    }

  });

});